## ignition-launch2 2.2.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.1 FATAL_ERROR)

#============================================================================
# Initialize the project
#============================================================================
project(ignition-launch2 VERSION 2.2.2)

#============================================================================
# Find ignition-cmake
#============================================================================
find_package(ignition-cmake2 2.8.0 REQUIRED)
set(IGN_CMAKE_VER ${ignition-cmake2_VERSION_MAJOR})

#============================================================================
# Configure the project
#============================================================================
ign_configure_project()

#============================================================================
# Set project-specific options
#============================================================================

set(IGN_LAUNCH_PLUGIN_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}/${IGN_LIB_INSTALL_DIR}/ign-${IGN_DESIGNATION}-${PROJECT_VERSION_MAJOR}/plugins/")

#============================================================================
# Search for project-specific dependencies
#============================================================================
message(STATUS "\n\n-- ====== Finding Dependencies ======")

#--------------------------------------
# Find Tinyxml2
ign_find_package(TINYXML2 REQUIRED PRIVATE PRETTY tinyxml2)

#--------------------------------------
# Find ignition-common
ign_find_package(ignition-common3 REQUIRED PRIVATE)
set(IGN_COMMON_MAJOR_VER ${ignition-common3_VERSION_MAJOR})

#--------------------------------------
# Find ignition-plugin
ign_find_package(ignition-plugin1 REQUIRED_BY launch COMPONENTS loader register)
set(IGN_PLUGIN_MAJOR_VER ${ignition-plugin1_VERSION_MAJOR})

#--------------------------------------
# Find ignition-tools
ign_find_package(ignition-tools
  REQUIRED
  PKGCONFIG "ignition-tools")

#--------------------------------------
# Find ignition-transport
ign_find_package(ignition-transport8 REQUIRED)
set(IGN_TRANSPORT_MAJOR_VER ${ignition-transport8_VERSION_MAJOR})

#--------------------------------------
# Find ignition-msgs
ign_find_package(ignition-msgs5 REQUIRED)
set(IGN_MSGS_MAJOR_VER ${ignition-msgs5_VERSION_MAJOR})

#--------------------------------------
# Find ignition-math
ign_find_package(ignition-math6 REQUIRED)
set(IGN_MATH_MAJOR_VER ${ignition-math6_VERSION_MAJOR})

#--------------------------------------
# Find ignition-gui
ign_find_package(ignition-gui3 REQUIRED)
set(IGN_GUI_MAJOR_VER ${ignition-gui3_VERSION_MAJOR})
ign_find_package (Qt5
  COMPONENTS
    Core
    Quick
    QuickControls2
  REQUIRED
  PKGCONFIG "Qt5Core Qt5Quick Qt5QuickControls2")

#--------------------------------------
# Find ignition-gazebo
ign_find_package(ignition-gazebo3 REQUIRED VERSION 3.4
  PRIVATE
    COMPONENTS gui
)
set(IGN_GAZEBO_MAJOR_VER ${ignition-gazebo3_VERSION_MAJOR})

ign_pkg_check_modules(websockets libwebsockets)
if (NOT websockets_FOUND)
  ign_build_warning("Unable to find libwebsockets. The websocket_server plugin will not be built.")
endif()

#--------------------------------------
# Find prerequistes for backward
include(src/vendor/BackwardConfig.cmake)

#============================================================================
# Add plugins
#============================================================================
add_subdirectory(plugins)

#============================================================================
# Configure the build
#============================================================================
ign_configure_build(QUIT_IF_BUILD_ERRORS)

#============================================================================
# install example .ign files
#============================================================================
add_subdirectory(examples)

#============================================================================
# Create package information
#============================================================================
ign_create_packages()

#============================================================================
# Configure documentation
#============================================================================
configure_file(${CMAKE_SOURCE_DIR}/api.md.in ${CMAKE_BINARY_DIR}/api.md)
configure_file(${CMAKE_SOURCE_DIR}/tutorials.md.in ${CMAKE_BINARY_DIR}/tutorials.md)

ign_create_docs(
  API_MAINPAGE_MD "${CMAKE_BINARY_DIR}/api.md"
  TUTORIALS_MAINPAGE_MD "${CMAKE_BINARY_DIR}/tutorials.md"
  TAGFILES
   "${IGNITION-MATH_DOXYGEN_TAGFILE} = ${IGNITION-MATH_API_URL}"
   "${IGNITION-MSGS_DOXYGEN_TAGFILE} = ${IGNITION-MSGS_API_URL}"
   "${IGNITION-PHYSICS_DOXYGEN_TAGFILE} = ${IGNITION-PHYSICS_API_URL}"
   "${IGNITION-PLUGIN_DOXYGEN_TAGFILE} = ${IGNITION-PLUGIN_API_URL}"
   "${IGNITION-TRANSPORT_DOXYGEN_TAGFILE} = ${IGNITION-TRANSPORT_API_URL}"
   "${IGNITION-SENSORS_DOXYGEN_TAGFILE} = ${IGNITION-SENSORS_API_URL}"
   "${IGNITION-COMMON_DOXYGEN_TAGFILE} = ${IGNITION-COMMON_API_URL}"
   "${IGNITION-GAZEBO_DOXYGEN_TAGFILE} = ${IGNITION-GAZEBO_API_URL}"
   "${IGNITION-GUI_DOXYGEN_TAGFILE} = ${IGNITION-GUI_API_URL}"
)

=== src/CMakeLists.txt ===
# add_subdirectory(plugins)

set (sources
  ign.cc
  Manager.cc
)

set (gtest_sources
  Manager_TEST.cc
  ign_TEST.cc
)

# Create the library target.
ign_create_core_library(SOURCES ${sources} CXX_STANDARD 17)

# Link the libraries that we always need.
target_link_libraries(${PROJECT_LIBRARY_TARGET_NAME}
  PUBLIC
    ignition-plugin${IGN_PLUGIN_MAJOR_VER}::loader
    ignition-plugin${IGN_PLUGIN_MAJOR_VER}::register
    TINYXML2::TINYXML2
  PRIVATE
    ignition-common${IGN_COMMON_MAJOR_VER}::ignition-common${IGN_COMMON_MAJOR_VER}
    ignition-math${IGN_MATH_MAJOR_VER}::ignition-math${IGN_MATH_MAJOR_VER}
    ${BACKWARD_LIBRARIES}
)

target_compile_definitions(${PROJECT_LIBRARY_TARGET_NAME} PRIVATE ${BACKWARD_DEFINITIONS})

# Build the unit tests.
ign_build_tests(TYPE UNIT SOURCES ${gtest_sources}
                EXCLUDE_PROJECT_LIB
                LIB_DEPS
                  ${PROJECT_LIBRARY_TARGET_NAME}
                  ignition-common${IGN_COMMON_MAJOR_VER}::ignition-common${IGN_COMMON_MAJOR_VER}
)

# Generate a the ruby script.
# Note that the major version of the library is included in the name.
# Ex: cmdlaunch0.rb
if (APPLE)
  set(IGN_LIBRARY_NAME lib${PROJECT_LIBRARY_TARGET_NAME}.dylib)
else()
  set(IGN_LIBRARY_NAME lib${PROJECT_LIBRARY_TARGET_NAME}.so)
endif()

configure_file(
  "cmdlaunch.rb.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmdlaunch${PROJECT_VERSION_MAJOR}.rb" @ONLY)


# Install the ruby command line library in an unversioned location.
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cmdlaunch${PROJECT_VERSION_MAJOR}.rb DESTINATION lib/ruby/ignition)

set(ign_library_path
  "${CMAKE_INSTALL_PREFIX}/lib/ruby/ignition/cmdlaunch${PROJECT_VERSION_MAJOR}")

# Generate a configuration file.
# Note that the major version of the library is included in the name.
# Ex: fuel0.yaml
configure_file(
  "launch.yaml.in"
    "${CMAKE_CURRENT_BINARY_DIR}/launch${PROJECT_VERSION_MAJOR}.yaml" @ONLY)

# Install the yaml configuration files in an unversioned location.
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/launch${PROJECT_VERSION_MAJOR}.yaml DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATAROOTDIR}/ignition/)

#===============================================================================
# Generate the ruby script for internal testing.
# Note that the major version of the library is included in the name.
# Ex: cmdlaunch0.rb
set(cmd_script_generated_test "${CMAKE_BINARY_DIR}/test/lib/ruby/ignition/cmdlaunch${PROJECT_VERSION_MAJOR}.rb")
set(cmd_script_configured_test "${cmd_script_generated_test}.configured")

# Set the library_location variable to the full path of the library file within
# the build directory.
set(IGN_LIBRARY_NAME "$<TARGET_FILE:${PROJECT_LIBRARY_TARGET_NAME}>")

configure_file(
  "cmdlaunch.rb.in"
  "${cmd_script_configured_test}"
  @ONLY)

file(GENERATE
  OUTPUT "${cmd_script_generated_test}"
  INPUT  "${cmd_script_configured_test}")

# Used only for internal testing.
set(ign_library_path "${CMAKE_BINARY_DIR}/test/lib/ruby/ignition/cmdlaunch${PROJECT_VERSION_MAJOR}")

# Generate a configuration file for internal testing.
# Note that the major version of the library is included in the name.
# Ex: launch0.yaml
configure_file(
  "launch.yaml.in"
    "${CMAKE_BINARY_DIR}/test/conf/launch${PROJECT_VERSION_MAJOR}.yaml" @ONLY)

=== include/ignition/CMakeLists.txt ===
add_subdirectory(launch)

=== plugins/joystick/CMakeLists.txt ===
set (plugin ignition-launch-joystick)
set (sources Joystick.cc)

add_library(${plugin} SHARED ${sources})
target_link_libraries(${plugin}
  PRIVATE
    ${PROJECT_LIBRARY_TARGET_NAME}
    ignition-common${IGN_COMMON_MAJOR_VER}::ignition-common${IGN_COMMON_MAJOR_VER}
    ignition-math${IGN_MATH_MAJOR_VER}::ignition-math${IGN_MATH_MAJOR_VER}
    ignition-transport${IGN_TRANSPORT_MAJOR_VER}::core
    ignition-plugin${IGN_PLUGIN_MAJOR_VER}::core
)

install (TARGETS ${plugin} DESTINATION ${IGN_LAUNCH_PLUGIN_INSTALL_PATH})

=== plugins/websocket_server/CMakeLists.txt ===
if (websockets_FOUND)
  set (plugin ignition-launch-websocket-server)
  set (sources WebsocketServer.cc)

  add_library(${plugin} SHARED ${sources})

  file (READ combined.proto WEBSOCKETSERVER_MESSAGE_DEFINITIONS)
  configure_file("MessageDefinitions.hh.in"
    "${CMAKE_CURRENT_BINARY_DIR}/MessageDefinitions.hh" @ONLY)
  # Add a dependency on binary source dir so that you can change the
  # combinded.proto file and `make` will rebuild the plugin.
  set_property(DIRECTORY APPEND PROPERTY CMAKE_CONFIGURE_DEPENDS combined.proto)
  target_include_directories(${plugin} PRIVATE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/>
  )

  target_link_libraries(${plugin}
    PRIVATE
      ${websockets_LIBRARIES}
      ${PROJECT_LIBRARY_TARGET_NAME}
      ignition-common${IGN_COMMON_MAJOR_VER}::ignition-common${IGN_COMMON_MAJOR_VER}
      ignition-msgs${IGN_MSGS_MAJOR_VER}::core
      ignition-plugin${IGN_PLUGIN_MAJOR_VER}::core
      ignition-transport${IGN_TRANSPORT_MAJOR_VER}::core
  )

  install (TARGETS ${plugin} DESTINATION ${IGN_LAUNCH_PLUGIN_INSTALL_PATH})
endif()

=== test/integration/CMakeLists.txt ===
set(TEST_TYPE "INTEGRATION")

add_subdirectory(plugins)

link_directories(${PROJECT_BINARY_DIR}/test)
include_directories(${PROJECT_SOURCE_DIR}/test)
include_directories(${PROJECT_SOURCE_DIR}/src)

set(tests faulty_plugins.cc)

ign_build_tests(TYPE INTEGRATION SOURCES ${tests} TEST_LIST test_targets)
foreach(test ${test_targets})
  target_compile_definitions(${test} PRIVATE
      "bad_plugins_LIB=\"$<TARGET_FILE:bad_plugins>\"")
endforeach()

=== debian/changelog ===
ignition-launch2 (2.2.2-1~buster) buster; urgency=medium

  * ignition-launch2 2.2.2-1 release

 -- Nate Koenig <nate@openrobotics.org>  Mon, 11 Oct 2021 17:18:14 -0700

ignition-launch2 (2.2.1-1~buster) buster; urgency=medium

  * ignition-launch2 2.2.1-1 release

 -- Nate Koenig <nate@openrobotics.org>  Fri, 08 Jan 2021 13:07:48 -0700

ignition-launch2 (2.2.0-1~buster) buster; urgency=medium

  * ignition-launch2 2.2.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Mon, 16 Nov 2020 09:47:41 -0800

ignition-launch2 (2.1.0-1~buster) buster; urgency=medium

  * ignition-launch2 2.1.0-1 release

 -- Nate Koenig <nate@openrobotics.org>  Thu, 21 May 2020 05:26:23 -0700

ignition-launch2 (2.0.1-3~buster) buster; urgency=medium

  * ignition-launch2 2.0.1-3 release

 -- Louise Poubel <louise@openrobotics.org>  Wed, 26 Feb 2020 12:51:39 -0800

=== debian/control ===
Source: ignition-launch2
Standards-Version: 3.9.4
Maintainer: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: science
Priority: extra
Build-Depends: cmake,
               debhelper (>= 7.0.50~),
               doxygen,
               libignition-cmake2-dev,
               libignition-common3-dev,
               libignition-gazebo3-dev (>= 3.4.0),
               libignition-gui3-dev,
               libignition-msgs5-dev,
               libignition-plugin-dev,
               libignition-tools-dev,
               libignition-transport8-dev,
               libsdformat9-dev,
               libtinyxml2-dev,
               libwebsockets-dev,
               qtquickcontrols2-5-dev,
               libqt5core5a,
               binutils-dev
Vcs-Browser: https://github.com/ignition-release/ign-launch2-release
Vcs-Hg: https://github.com/ignition-release/ign-launch2-release
Homepage: https://github.com/ignition-release/ign-launch2

Package: libignition-launch2
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Ignition Robotics Launch Library - Launch libraries

Package: libignition-launch2-dev
Architecture: any
Section: libdevel
Depends: libignition-cmake2-dev,
	 libignition-common3-dev,
	 libignition-gazebo3-dev (>= 3.4.0),
	 libignition-gui3-dev,
	 libignition-msgs5-dev,
	 libignition-plugin-dev,
	 libignition-tools-dev,
	 libignition-transport8-dev,
	 libtinyxml2-dev ,
	 libwebsockets-dev,
	 qtquickcontrols2-5-dev,
	 libqt5core5a,
	 libignition-launch2 (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Ignition Robotics Launch Library - Launch libraries
  Ignition Common is a component in the ignition framework, a set of libraries
  designed to rapidly develop robot applications.

## ignition-launch2 2.3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,12 +3,12 @@
 #============================================================================
 # Initialize the project
 #============================================================================
-project(ignition-launch2 VERSION 2.2.2)
+project(ignition-launch2 VERSION 2.3.0)
 
 #============================================================================
 # Find ignition-cmake
 #============================================================================
-find_package(ignition-cmake2 2.8.0 REQUIRED)
+find_package(ignition-cmake2 2.14.0 REQUIRED)
 set(IGN_CMAKE_VER ${ignition-cmake2_VERSION_MAJOR})
 
 #============================================================================
@@ -20,7 +20,7 @@
 # Set project-specific options
 #============================================================================
 
-set(IGN_LAUNCH_PLUGIN_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}/${IGN_LIB_INSTALL_DIR}/ign-${IGN_DESIGNATION}-${PROJECT_VERSION_MAJOR}/plugins/")
+set(IGN_LAUNCH_PLUGIN_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}/${IGN_LIB_INSTALL_DIR}/ign-${GZ_DESIGNATION}-${PROJECT_VERSION_MAJOR}/plugins/")
 
 #============================================================================
 # Search for project-specific dependencies
@@ -46,6 +46,10 @@
 ign_find_package(ignition-tools
   REQUIRED
   PKGCONFIG "ignition-tools")
+# Note that CLI files are installed regardless of whether the dependency is
+# available during build time
+find_program(HAVE_IGN_TOOLS ign)
+set(IGN_TOOLS_VER 1)
 
 #--------------------------------------
 # Find ignition-transport

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -34,6 +34,21 @@
                   ${PROJECT_LIBRARY_TARGET_NAME}
                   ignition-common${IGN_COMMON_MAJOR_VER}::ignition-common${IGN_COMMON_MAJOR_VER}
 )
+
+if(TARGET UNIT_ign_TEST)
+  # Running `ign launch` on macOS has problems when run with /usr/bin/ruby
+  # due to System Integrity Protection (SIP). Try to find ruby from
+  # homebrew as a workaround.
+  if (APPLE)
+    find_program(BREW_RUBY ruby HINTS /usr/local/opt/ruby/bin)
+  endif()
+
+  target_compile_definitions(UNIT_ign_TEST PRIVATE
+      "BREW_RUBY=\"${BREW_RUBY} \"")
+
+  target_compile_definitions(UNIT_ign_TEST PRIVATE
+      "IGN_PATH=\"${HAVE_IGN_TOOLS}\"")
+endif()
 
 # Generate a the ruby script.
 # Note that the major version of the library is included in the name.
@@ -94,3 +109,16 @@
 configure_file(
   "launch.yaml.in"
     "${CMAKE_BINARY_DIR}/test/conf/launch${PROJECT_VERSION_MAJOR}.yaml" @ONLY)
+
+#===============================================================================
+# Bash completion
+
+# Tack version onto and install the bash completion script
+configure_file(
+  "launch.bash_completion.sh"
+    "${CMAKE_CURRENT_BINARY_DIR}/launch${PROJECT_VERSION_MAJOR}.bash_completion.sh" @ONLY)
+install(
+  FILES
+    ${CMAKE_CURRENT_BINARY_DIR}/launch${PROJECT_VERSION_MAJOR}.bash_completion.sh
+  DESTINATION
+    ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATAROOTDIR}/gz/gz${IGN_TOOLS_VER}.completion.d)

=== debian/changelog ===
ignition-launch2 (2.3.0-1~focal) focal; urgency=medium

  * ignition-launch2 2.3.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Tue, 16 Aug 2022 09:56:08 -0700

ignition-launch2 (2.2.2-1~focal) focal; urgency=medium

  * ignition-launch2 2.2.2-1 release

 -- Nate Koenig <nate@openrobotics.org>  Mon, 11 Oct 2021 17:18:14 -0700

ignition-launch2 (2.2.1-1~focal) focal; urgency=medium

  * ignition-launch2 2.2.1-1 release

 -- Nate Koenig <nate@openrobotics.org>  Fri, 08 Jan 2021 13:07:48 -0700

ignition-launch2 (2.2.0-1~focal) focal; urgency=medium

  * ignition-launch2 2.2.0-1 release

 -- Louise Poubel <louise@openrobotics.org>  Mon, 16 Nov 2020 09:47:41 -0800

ignition-launch2 (2.1.0-1~focal) focal; urgency=medium

  * ignition-launch2 2.1.0-1 release

 -- Nate Koenig <nate@openrobotics.org>  Thu, 21 May 2020 05:26:23 -0700

ignition-launch2 (2.0.1-3~focal) focal; urgency=medium

  * ignition-launch2 2.0.1-3 release

 -- Louise Poubel <louise@openrobotics.org>  Wed, 26 Feb 2020 12:51:39 -0800

=== debian/control ===
Source: ignition-launch2
Standards-Version: 3.9.4
Maintainer: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: science
Priority: extra
Build-Depends: cmake,
               debhelper (>= 7.0.50~),
               doxygen,
               libignition-cmake2-dev (>= 2.14.0),
               libignition-common3-dev,
               libignition-gazebo3-dev (>= 3.4.0),
               libignition-gui3-dev,
               libignition-msgs5-dev,
               libignition-plugin-dev,
               libignition-tools-dev,
               libignition-transport8-dev,
               libsdformat9-dev,
               libtinyxml2-dev,
               libwebsockets-dev,
               qtquickcontrols2-5-dev,
               libqt5core5a,
               binutils-dev
Vcs-Browser: https://github.com/gazebosim/gz-launch
Vcs-Git: https://github.com/gazebosim/gz-launch
Homepage: https://github.com/gazebosim/gz-launch

Package: libignition-launch2
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Gazebo Launch Library - Launch libraries

Package: libignition-launch2-dev
Architecture: any
Section: libdevel
Depends: libignition-cmake2-dev (>= 2.14.0),
	 libignition-common3-dev,
	 libignition-gazebo3-dev (>= 3.4.0),
	 libignition-gui3-dev,
	 libignition-msgs5-dev,
	 libignition-plugin-dev,
	 libignition-tools-dev,
	 libignition-transport8-dev,
	 libtinyxml2-dev ,
	 libwebsockets-dev,
	 qtquickcontrols2-5-dev,
	 libqt5core5a,
	 libignition-launch2 (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Gazebo Launch Library - Launch libraries
  Gazebo Common is a component in the Gazebo framework, a set of libraries
  designed to rapidly develop robot applications.

Package: libgz-launch2
Depends: libignition-launch2, ${misc:Depends}
Architecture: all
Priority: optional
Section: oldlibs
Description: transitional package
 It's recommended to use the gz packages going forward.

Package: libgz-launch2-dev
Depends: libignition-launch2-dev, ${misc:Depends}
Architecture: all
Priority: optional
Section: oldlibs
Description: transitional package
 It's recommended to use the gz packages going forward.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)

.PHONY: override_dh_auto_configure \
        override_dh_install

%:
	dh $@ --parallel

override_dh_install:
	dh_install --
	dh_missing --list-missing

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DCMAKE_BUILD_TYPE=RelWithDebInfo

=== debian/watch ===
version=3
http://gazebosim.org/distributions/ign-plugin/releases/ignition-plugin-(\d\.\d\.\d)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## ignition-launch2 2.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #============================================================================
 # Initialize the project
 #============================================================================
-project(ignition-launch2 VERSION 2.3.0)
+project(ignition-launch2 VERSION 2.3.1)
 
 #============================================================================
 # Find ignition-cmake

=== debian/changelog ===
ignition-launch2 (2.3.1-1~focal) focal; urgency=medium

  * ignition-launch2 2.3.1-1 release

 -- Addisu Z. Taddese <addisu@openrobotics.org>  Fri, 05 Jan 2024 19:07:44 -0600
